import type { AgentMessage } from './AgentMessage';
import type { Handler } from './Handler';
import type { InboundMessageContext } from './models/InboundMessageContext';
import { AgentConfig } from '../agent/AgentConfig';
import { EventEmitter } from './EventEmitter';
import { MessageSender } from './MessageSender';
declare class Dispatcher {
    private handlers;
    private messageSender;
    private eventEmitter;
    private logger;
    constructor(messageSender: MessageSender, eventEmitter: EventEmitter, agentConfig: AgentConfig);
    registerHandler(handler: Handler): void;
    dispatch(messageContext: InboundMessageContext): Promise<void>;
    private getHandlerForType;
    getMessageClassForType(messageType: string): typeof AgentMessage | undefined;
    get supportedMessageTypes(): string[];
}
export { Dispatcher };
