import { AgentMessage } from '../../../agent/AgentMessage';
import { PresentationPreview } from './PresentationPreview';
export interface ProposePresentationMessageOptions {
    id?: string;
    comment?: string;
    presentationProposal: PresentationPreview;
}
/**
 * Propose Presentation Message part of Present Proof Protocol used to initiate presentation exchange by holder.
 *
 * @see https://github.com/hyperledger/aries-rfcs/blob/master/features/0037-present-proof/README.md#propose-presentation
 */
export declare class ProposePresentationMessage extends AgentMessage {
    constructor(options: ProposePresentationMessageOptions);
    readonly type = "https://didcomm.org/present-proof/1.0/propose-presentation";
    static readonly type = "https://didcomm.org/present-proof/1.0/propose-presentation";
    /**
     * Provides some human readable information about the proposed presentation.
     */
    comment?: string;
    /**
     * Represents the presentation example that prover wants to provide.
     */
    presentationProposal: PresentationPreview;
}
