import { AgentMessage } from '../../../agent/AgentMessage';
import { WireMessage } from '../../../types';
export declare class BatchMessageMessage {
    constructor(options: {
        id?: string;
        message: WireMessage;
    });
    id: string;
    message: WireMessage;
}
export interface BatchMessageOptions {
    id?: string;
    messages: BatchMessageMessage[];
}
/**
 * A message that contains multiple waiting messages.
 *
 * @see https://github.com/hyperledger/aries-rfcs/blob/master/features/0212-pickup/README.md#batch
 */
export declare class BatchMessage extends AgentMessage {
    constructor(options: BatchMessageOptions);
    readonly type = "https://didcomm.org/messagepickup/1.0/batch";
    static readonly type = "https://didcomm.org/messagepickup/1.0/batch";
    messages: BatchMessageMessage[];
}
