import { AgentMessage } from '../../../agent/AgentMessage';
import { WireMessage } from '../../../types';
export interface ForwardMessageOptions {
    id?: string;
    to: string;
    message: WireMessage;
}
/**
 * @see https://github.com/hyperledger/aries-rfcs/blob/master/concepts/0094-cross-domain-messaging/README.md#corerouting10forward
 */
export declare class ForwardMessage extends AgentMessage {
    /**
     * Create new ForwardMessage instance.
     *
     * @param options
     */
    constructor(options: ForwardMessageOptions);
    readonly type = "https://didcomm.org/routing/1.0/forward";
    static readonly type = "https://didcomm.org/routing/1.0/forward";
    to: string;
    message: WireMessage;
}
